--******************************************************************************************************
--[[
	Autor: Bo
	E-Mail: webmaster@myrtana.de

	Vielen Dank an Quel <qwarlock@gmail.com> fr qRanger, an dessen Tool ich mich orientierte.
--]]

ranger_version = 0.2;
ranger_on = 1;
local Ronesec = 0;

-- Initialization
function RangerFrame_OnLoad()
	
	-- UI Commands

	SLASH_Ranger1 = "/sr";
	SLASH_Ranger2 = "/ranger";
	SlashCmdList["Ranger"] = Ranger_SlashHandler;

	RangerFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
	RangerFrame:EnableMouse(0);

	ChatFrame1:AddMessage(format(LOC_STARTUP, ranger_version));
	UIErrorsFrame:AddMessage("SimpleRange Loaded.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
	
end

--******************************************************************************************************
-- Handles UI  commands
function Ranger_SlashHandler(arg1)
	local str;
	local opt;

	if(arg1 == "") then
		ChatFrame1:AddMessage(format(CONFIG_STARTUP, ranger_version));
		ChatFrame1:AddMessage(CONFIG_HELP_ONOFF);
		if (ranger_on == 0) then
			ChatFrame1:AddMessage(CONFIG_MESSAGE_OFF);
		else
			ChatFrame1:AddMessage(CONFIG_MESSAGE_ON);
		end
		
		return;
	end

	opt=string.find(arg1,"off");
	if (opt ~= nil) then
		RangerFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
		RangerFrame:Hide();
		ChatFrame1:AddMessage(CONFIG_MESSAGE_OFF);

		ranger_on = 0;
		return;
	end

	opt=string.find(arg1,"on");
	if (opt ~= nil) then
		RangerFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
		ChatFrame1:AddMessage(CONFIG_MESSAGE_ON);
		RangerFrame:Show();

		ranger_on = 1;
		return;
	end

end

--******************************************************************************************************
-- Event handler 
-- variables: event = the event code, arg1= message shown to player upon that event, 
--	arg2= so far always blank

function RangerFrame_OnEvent(event,arg1)

	if (ranger_on == 0) then
		return;
	end

	if (event ~= "PLAYER_TARGET_CHANGED") then
		return;
	end

	RangerText:SetText(" ");

end

--******************************************************************************************************
-- OnUpdate is called apparently everytime a new Frame is drawn, according to 
--	the sources on the web. arg1 = number of seconds since last time OnUpdate was called.

function RangerFrame_OnUpdate(arg1)
	
	
	if ( (ranger_on == 0) or 
	     (nil == UnitName("target") ) ) then
		return;
	end

	Ronesec=Ronesec+arg1;	-- allow screen writes no more than 1 per second.
	
	if (Ronesec > .33 ) then
			
			if(UnitExists("target") == 1)then
			
				local R1,R2,R3,R4,R5;
				if(CheckInteractDistance("target", 1)) then R1 = 1; else R1 = 0; end
				if(CheckInteractDistance("target", 2)) then R2 = 1; else R2 = 0; end
				if(CheckInteractDistance("target", 3)) then R3 = 1;	else R3 = 0; end
				if(CheckInteractDistance("target", 4)) then R4 = 1; else R4 = 0; end
				if(nil==CheckInteractDistance("target", 4)) then R5 = 1; else R5 = 0; end
				
				if(R4 == 1 and R3 == 0) then
				-- 28m=Y 10m=N
					RangerText:SetText(format("|cFFFFD000 %s: |cffffffff10-28",LOC_RANGE));
				elseif(R3 == 1 and R1 == 0) then
				-- 10m=Y 5m=N
					RangerText:SetText(format("|cFFFFD000 %s: |cffffffff5-10",LOC_RANGE));
				elseif(R1 == 1) then
				-- 5m=Y
					RangerText:SetText(format("|c000ffb00 %s: |cffffffff0-5",LOC_RANGE));
				elseif(R5 == 1) then
				-- 28m=N
					RangerText:SetText(format("|cFFF00023 %s: |cffffffff>28",LOC_RANGE));
				end
				
			else
				RangerText:SetText(" ");
			end

		Ronesec = 0;
	end
end

